#include <iostream>
#include <iomanip>
#include <cmath>

struct point {
       double x, y;
};

struct line {
       point origin;
       double xlen, ylen;
};

struct lineFC {
       double a, b;
};

void makeLineFC(lineFC* l, point& a, point& b) {
     l->a = (b.y - a.y)/(b.x - a.x);
     l->b = a.y - (l->a)*(a.x);
}

void makeLine(line* l, point& p1, point& p2) {
     l->origin.x = p1.x;
     l->origin.y = p1.y;
     l->xlen = p1.x - p2.x;
     l->ylen = p1.y - p2.y;
}

bool presicha(point* p, line& l1, line& l2) {
     if (l1.xlen == l2.xlen && l1.ylen == l2.ylen) return false;
     if (l1.xlen==0) {
        lineFC l;
        point pFC;
        pFC.x = l2.origin.x + l2.xlen;
        pFC.y = l2.origin.y + l2.ylen;
        makeLineFC(&l, l2.origin, pFC);
        p->x = l1.origin.x;
        p->y = l.a*(l1.origin.x) + l.b;
        //if ((p->y < (l1.origin.y)) || (p->y > (l1.origin.y + l1.ylen))) {p->x = p->y = 0; return false;}
        return true;
     }
     else if (l2.xlen == 0) {
          lineFC l;
          point pFC;
          pFC.x = l1.origin.x + l1.xlen;
          pFC.y = l1.origin.y + l1.ylen;
          makeLineFC(&l, l1.origin, pFC);
          p->x = l2.origin.x;
          p->y = l.a*(l2.origin.x) + l.b;
          //if ((p->x < (l1.origin.x)) || (p->x > (l1.origin.x+l1.xlen))) {p->x = p->y = 0; return false;}
          //if ((p->y < (l1.origin.x)) || (p->y > (l1.origin.y+l1.ylen))) {p->x = p->y = 0; return false;}
          return true;
     }
     else {
          lineFC l11, l22;
          point pFC;
          pFC.x = l1.origin.x + l1.xlen;
          pFC.y = l1.origin.y + l1.ylen;
          makeLineFC(&l11, l1.origin, pFC);
          pFC.x = l2.origin.x + l2.xlen;
          pFC.y = l2.origin.y + l2.ylen;
          makeLineFC(&l22, l2.origin, pFC);
          p->x = (l22.b- l11.b)/(l11.a- l22.a);
          p->y = l11.a*(p->x) + l11.b;
          //if ((p->x < (l1.origin.x)) || (p->x > (l1.origin.x+l1.xlen))) {p->x = p->y = 0; return false;}
          //if ((p->y < (l1.origin.x)) || (p->y > (l1.origin.y+l1.ylen))) {p->x = p->y = 0; return false;}
          return true;
     }
}

double calcEv(point& p1, point& p2) {
       double x = p1.x - p2.x, y = p1.y - p2.y;
       return std::sqrt(x*x + y*y);
}

bool isBTN(double c, double cp1, double cp2) {
     if ((c>=cp1) && (c<=cp2)) return true;
     if ((c>=cp2) && (c<=cp1)) return true;
     return false;
}
     
     

int main() {
    point p1, p2, p3, m, n, rp1, rp2;
    std::cin >> p1.x >> p1.y >> p2.x >> p2.y >> p3.x >> p3.y >> m.x >> m.y >> n.x >> n.y;
    line reb1, reb2, reb3, l;
    makeLine(&reb1, p1, p2);
    makeLine(&reb2, p1, p3);
    makeLine(&reb3, p2, p3);
    makeLine(&l, m, n);
    rp1.x = rp1.y = rp2.x = rp2.y = 0;
    for (int i = 0; i<1; i++) {
    if (presicha(&rp1, reb1, l)) {
       if (!isBTN(rp1.x, reb1.origin.x, reb1.origin.x-reb1.xlen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0; break;}
       if (!isBTN(rp1.y, reb1.origin.y, reb1.origin.y-reb1.ylen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
       if (presicha(&rp2, reb2, l)) {
          if (!isBTN(rp2.x, reb2.origin.x, reb2.origin.x-reb2.xlen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0; break;}
         if (!isBTN(rp2.y, reb2.origin.y, reb2.origin.y-reb2.ylen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
       }
       else {
            presicha(&rp2, reb3, l);
            if (!isBTN(rp2.x, reb3.origin.x, reb3.origin.x-reb3.xlen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0; break;}
            if (!isBTN(rp2.y, reb3.origin.y, reb3.origin.y-reb3.ylen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
       }
    }
    else {
         presicha(&rp1, reb2, l);
         if (!isBTN(rp1.x, reb2.origin.x, reb2.origin.x-reb2.xlen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0; break;}
         if (!isBTN(rp1.y, reb2.origin.y, reb2.origin.y-reb2.ylen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
         presicha(&rp2, reb3, l);
         if (!isBTN(rp2.x, reb3.origin.x, reb3.origin.x-reb3.xlen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
         if (!isBTN(rp2.y, reb3.origin.y, reb3.origin.y-reb3.ylen)) {rp1.x = rp2.x = rp1.y = rp2.y = 0;break;}
    }
    }
    //std::cout << rp1.x << ' ' << rp1.y << ' ' << rp2.x << ' ' << rp2.y << '\n';
    double rez = calcEv(rp1, rp2);
    if ((rez - (int)rez)==0) std::cout << rez << ".000";
    else std::cout << rez << "00";
    return 0;
}
