#include <iostream>
#include <iomanip>
#include <cmath>

using namespace std;

struct koef{
  double a, b;
};

struct coord{
  double x, y;
};

double pravaa(coord P, coord Q){
 return (P.y-Q.y)/(P.x-Q.x);
}

double pravab(coord P, coord Q){
 return (P.y*Q.x-P.x*Q.y)/(Q.x-P.x);
}

double presto4kax(koef y1, koef y2){
 //if(y1.a == y2.a) return 1;
 return (y2.b-y1.b)/(y1.a-y2.a);
}

double presto4kay(koef y1, koef y2){
 return (y1.a*y2.b-y2.a*y1.b)/(y1.a-y2.a);
}

bool vytr(coord D, coord E, coord F){ //dali E e m/u D i F
 if ( (E.x-D.x)*(E.x-F.x)<=0 && (E.y-D.y)*(E.y-F.y)<=0 )  return true;
 return false;
}

double dist(coord A, coord B){
 return sqrt( (A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y) );
}


int main()
{
 coord A, B, C, M, N, K, L, R;

 cin >> A.x >> A.y >> B.x >> B.y >> C.x >> C.y ;
 cin >> M.x >> M.y >> N.x >> N.y ;

 koef s, a, b, c;

 s.a=pravaa(M, N);
 s.b=pravab(M, N);
 a.a=pravaa(B, C);
 a.b=pravab(B, C);
 b.a=pravaa(C, A);
 b.b=pravab(C, A);
 c.a=pravaa(A, B);
 c.b=pravab(A, B);

// cout<<s.a<<" "<<s.b<<endl;

 if (s.a==a.a)
    {K.x=presto4kax(s,b);
     R.x=presto4kax(s,c);
     K.y=presto4kay(s,b);
     R.y=presto4kay(s,c);
     if(s.b==a.b) {cout << setiosflags(ios::fixed) << setprecision(4) << dist (B,C) <<endl;
                   return 0;}
     if(vytr(A,K,C)&&vytr(A,R,B))
        {cout << setiosflags(ios::fixed) << setprecision(4) <<dist(K,R)<<endl; return 0;}
    }
 if (s.a==b.a)
    {L.x=presto4kax(s,a);
     R.y=presto4kay(s,c);
     R.x=presto4kax(s,c);
     L.y=presto4kay(s,a);
     if(s.b==b.b) {cout << setiosflags(ios::fixed) << setprecision(4) << dist (A,C) <<endl;
                    return 0;}
     if(vytr(A,R,B)&&vytr(B,L,C))
       {cout << setiosflags(ios::fixed) << setprecision(4) <<dist(R,L)<<endl; return 0;}
    }
 if (s.a==c.a)
    { L.x=presto4kax(s,a);
      K.x=presto4kax(s,b);
      L.y=presto4kay(s,a);
      K.y=presto4kay(s,b);
      if(s.b==c.b) {cout << setiosflags(ios::fixed) << setprecision(4) << dist (A,B) <<endl;
                    return 0;}
      if(vytr(A,K,C)&&vytr(C,L,B))
       {cout << setiosflags(ios::fixed) << setprecision(4) <<dist(K,L)<<endl; return 0;}
    }

 if (s.a==a.a || s.a==b.a || s.a==c.a )   {cout<<"0.0000"; return 0;}

 L.x=presto4kax(s,a);
 K.x=presto4kax(s,b);
 R.x=presto4kax(s,c);
 L.y=presto4kay(s,a);
 K.y=presto4kay(s,b);
 R.y=presto4kay(s,c);

 if( vytr(K,A,B) ){
    if( vytr(L,B,C) ) cout << dist(L,K) <<endl;
    else cout  << setiosflags(ios::fixed) << setprecision(4) << dist(K,R)<<endl;
   }
 else cout << setiosflags(ios::fixed) << setprecision(4) << dist(L,R) <<endl;

 return 0;

}
