#include <stdio.h>
#include <vector>
#include <queue>
#define FOR(i,n) for(int i=0;i<(int)n;i++)
#define maxn 100001

std::vector<int> v[maxn];
int parent[maxn];
int depth[maxn];
bool used[maxn];
int n,m;

void init() {
    scanf("%d%d",&n,&m);
    FOR(i,n) {
        int c;
        scanf("%d",&c);
        v[i+1].push_back(c);
        v[c].push_back(i+1);
        used[i] = 0;
    }    
}

void bfs(){
    std::queue<int> q;
    q.push(0);
    used[0] = 1;
    parent[0] = 0;
    depth[0] = 0;
    while(!q.empty()) {
        int fr = q.front();
        q.pop();
        FOR(i,v[fr].size()) {
            int el(v[fr][i]);
           if(!used[ el ]) {
               used[ el ] = 1;
               parent[ el ] = fr;
               depth[ el ] = depth[ fr ] + 1;
               q.push(v[fr][i]);
           }    
       }    
    }    
}    

int lca(int a,int b) {
    int ca(a),cb(b);
    while(ca!=cb) {
        if(depth[ca]>depth[cb]) ca = parent[ca];
        else if(depth[ca]<depth[cb]) cb = parent[cb];
        else { ca=parent[ca]; cb=parent[cb]; }
    }    
    return ca;
}    

int main() {
    init();    
    bfs();
    FOR(i,m) {
        int a,b;
        scanf("%d %d",&a,&b);
        printf("%d\n",lca(a,b));
    }    
    return 0;
}
